Index Page mxmtg_c
A B C D E F G H I J K L M N O P Q R S T U V W X
Procedure Abstract Required_Reading Keywords Brief_I/O Detailed_Input | Detailed_Output Parameters Exceptions Files Particulars Examples | Restrictions Literature_References Author_and_Institution Version Index_Entries
#### Procedure
       void mxmtg_c ( const void   * m1,
                      const void   * m2,
                      SpiceInt       nrow1,
                      SpiceInt       nc1c2,
                      SpiceInt       nrow2,
                      void         * mout  )
#### Abstract
       Multiply a matrix and the transpose of a matrix, both of
       arbitrary size.
#### Required_Reading
       None.
#### Keywords
       MATRIX
#### Brief_I/O
       VARIABLE  I/O  DESCRIPTION
       --------  ---  --------------------------------------------------
       m1         I   Left-hand matrix to be multiplied.
       m2         I   Right-hand matrix whose transpose is to be multiplied
       nrow1      I   Row dimension of m1 and row dimension of mout.
       nc1c2      I   Column dimension of m1 and column dimension of m2.
       nrow2      I   Row dimension of m2 and column dimension of mout.
       mout       O   Product matrix.
#### Detailed_Input
       m1         may be any double precision matrix of arbitrary size.

       m2         may be any double precision matrix of arbitrary size.
                  The number of columns in m2 must match the number of
                  columns in m1.

       nrow1      is the number of rows in both m1 and mout.

       nc1c2      i the number of columns in m1 and (by necessity) the
                  number of columns of m2.

       nrow2      is the number of rows in both m2 and the number of columns
                  in mout.
#### Detailed_Output
       mout       is the product matrix given by

                                       t
                     mout = (m1) x (m2)

                  where the superscript "t" denotes the transpose matrix.
                  This is a double precision matrix of dimension nrow1 x
                  nrow2.

                  mout may overwrite m1 or m2.  Note that this capability
                  does not exist in the Fortran version of SPICELIB; in the
                  Fortran version, the output must not overwrite either
                  input.
#### Parameters
       None.
#### Exceptions
       Error free.
#### Files
       None.
#### Particulars
       The code reflects precisely the following mathematical expression

          For each value of the subscript i from 1 to nrow1, and j from 1
          to nrow2:

          mout(i,j) = summation from k=1 to nc1c2 of  ( m1(i,k) * m2(j,k) )

       Notice that the order of the subscripts of m2 are reversed from
       what they would be if this routine merely multiplied m1 and m2.
       It is this transposition of subscripts that makes this routine
       multiply m1 and the TRANPOSE of m2.
#### Examples
       1)  Let m1 =

              | 1.0  2.0  3.0 |
              |               |
              | 3.0  2.0  1.0 |

           Let m2 =

              | 1.0  2.0  0.0 |
              |               |
              | 2.0  1.0  2.0 |
              |               |
              | 1.0  2.0  0.0 |
              |               |
              | 2.0  1.0  2.0 |

           Here

              nrow1   = 2
              nc1c2   = 3
              nrow2   = 4

           so the call

              mxmtg_c ( m1, m2, nrow1, nc1c2, nrow2, mout );

           produces the matrix

              mout = | 5.0  10.0  5.0  10.0 |
                     |                      |
                     | 7.0  10.0  7.0  10.0 |
#### Restrictions
       No error checking is performed to prevent numeric overflow or
       underflow.

       No error checking is performed to determine if the input and
       output matrices have, in fact, been correctly dimensioned.

       The user is responsible for checking the magnitudes of the
       elements of m1 and m2 so that a floating point overflow does
       not occur.
#### Literature_References
       None.
#### Author_and_Institution
       N.J. Bachman    (JPL)
       W.M. Owen       (JPL)
#### Version
       -CSPICE Version 1.2.0, 28-AUG-2001 (NJB)

          Const-qualified input arrays.

       -CSPICE Version 1.1.0, 08-FEB-1998 (NJB)

          Corrected a comment describing the local macro INDEX.   Made
          miscellaneous code format corrections.

       -CSPICE Version 1.0.0, 25-OCT-1997 (NJB)

          Based on SPICELIB Version 1.0.1, 10-MAR-1992 (WLT)
#### Index_Entries
       matrix times matrix_transpose n-dimensional_case
#### Link to routine mxmtg_c source file mxmtg_c.c

    Wed Jun  9 13:05:26 2010